<?
//  require "../relation_types/relation_cache.php";
  
  class HValue {
    var $conn;  //connection handle
    
    var $atrtid;  //attribute type id
    var $relid;    //base relation id
    
    var $oid;      //hatr_id
    var $value;    //atrt_value
    
    var $parents;  //array of parent nodes: for each i -> base($parents[i], $oid);
        
    function HValue($conn, $atrtid, $relid) {
      $this->conn = $conn;
      $this->atrtid = $atrtid;
      $this->relid = $relid;
    }
    
    function newOid() {
      $rs = ODBC_Exec($this->conn, "SELECT Count(HATR_ID) as _COUNT, Max(HATR_ID) as _MAX FROM H_ATRT_VALUES");
      ODBC_Fetch_Row($rs);
      $count = ODBC_Result($rs, 1);
      $max =  ODBC_Result($rs, 2);
      
      if($count == 0)
        return 1;
      else
        return ($max + 1);
    }
    
    function validate() {
      if(Empty($this->value)) {
        write_error("Name must be non-empty string!");
        return false;
      }
      if(Empty($this->parents) || !Is_Array($this->parents) || Count($this->parents)<1) {
        write_error("Each node must have at least one parent!");
         return false;
      }
      return true;
    }

    /* helper for create, modify, delete */    
    function removeParents() {
      //relation changed
      $rc = new RelationCache($this->conn, $this->relid);
      $rc->invalidate();
      
      $command = "DELETE FROM RELATIONS WHERE RLN_ID=".$this->relid;
      $command .= " AND HATR_ID_R=".$this->oid;
      
      ODBC_Exec($this->conn, $command);
    }

    /* helper for create and modify */
    function writeParents() {
      /* Cache invalidation should be here,
         however, removeParents() is always called
         before writeParents() in current implementation.
         
         Result: Cache invalidation omitted - performance reason.
      */

      $command = "INSERT INTO RELATIONS (RLN_ID, HATR_ID_L, HATR_ID_R)";
      $command .= " VALUES (".$this->relid;
      $command .= " , ?, ".$this->oid;
      $command .= ")";
      
      $handle = ODBC_Prepare($this->conn, $command);
      for($i=0; $i<Count($this->parents); $i++) {
        ODBC_Execute($handle, Array($this->parents[$i]));
      }
      
    }
    
    function loadParents() {
      $command = "SELECT HATR_ID_L FROM RELATIONS WHERE RLN_ID=".$this->relid;
      $command .= " AND HATR_ID_R=".$this->oid;
      
      $rs = ODBC_Exec($this->conn, $command);
      $parents = Array();
      while(ODBC_Fetch_Row($rs)) {
        $parents[] = ODBC_Result($rs, 1);
      }
      $this->parents = $parents;
    }
    
    function create() {
      
      /* insert into H_ATRT_VALUES */
      $command = "INSERT INTO H_ATRT_VALUES (HATR_ID, ATRT_ID, ATRT_VALUE) VALUES (";
      $command .= $this->oid;
      $command .= ", " . $this->atrtid;
      $command .= ", '" . $this->value;
      $command .= "')";
      
      //debug_trace($command);
      ODBC_Exec($this->conn, $command);
      
      /* (re-)create base relation part */
      $this->removeParents(); //for just a case
      $this->writeParents();   //put this node into a dimension structure
    }
    
    function modify() {
      $command = "UPDATE H_ATRT_VALUES SET ATRT_VALUE='".$this->value;
      $command .= "' WHERE HATR_ID=".$this->oid;
      $command .= " AND ATRT_ID=".$this->atrtid;

      //debug_trace($command);
      ODBC_Exec($this->conn, $command);
      
      /* (re-)create base relation part */
      $this->removeParents();
      $this->writeParents();   //put this node into a dimension structure
    }
    
    function load($oid) {
      $command = "SELECT HATR_ID, ATRT_VALUE FROM H_ATRT_VALUES WHERE HATR_ID=".$oid;
      $command .= " AND ATRT_ID=".$this->atrtid;

      //debug_trace($command);
      $rs = ODBC_Exec($this->conn, $command);
      if(!ODBC_Fetch_Row($rs))
        return false;
      $this->oid = ODBC_Result($rs, 1);
      $this->value = ODBC_Result($rs, 2);
      
      
      $this->loadParents();
      
      return true;
    }
    
    function canDelete() {
      return true;
    }
    
    function delete() {
      //precondition
      if(!$this->canDelete()) {
        return false;
      }
      
      $this->removeParents();
            
      $command = "DELETE FROM H_ATRT_VALUES WHERE HATR_ID=".$this->oid;
      $command .= " AND ATRT_ID=".$this->atrtid;
      
      //debug_trace($command);
      ODBC_Exec($this->conn, $command);      
      
      return true;
    }
    
    /* loads dimension values */
    function loadDimVals(&$ids, &$vals) {
      $command = "SELECT HATR_ID, ATRT_VALUE FROM H_ATRT_VALUES WHERE ATRT_ID=".$this->atrtid;
      $command .= " ORDER BY ATRT_VALUE";
      
      $rs = ODBC_Exec($this->conn, $command);
      while(ODBC_Fetch_Row($rs)) {
        $ids[] = ODBC_Result($rs, 1);
        $vals[] = ODBC_Result($rs, 2);
      }
    }
  }
?>