<?

  /* helper class */
  class Attribute {
    var $atid;
    var $atname;
    var $atflag;
    var $atvalue;
  }
  
  class Object {
    var $conn;  //connection handle
    
    var $oid;
    var $otid;
    var $name;
    var $descr;
    
    function Object($conn) {
      $this->conn = $conn;
    }
    
    function newOid() {
      $rs = ODBC_Exec($this->conn, "SELECT Count(OID) as _COUNT, Max(OID) as _MAX FROM OBJECTS");
      ODBC_Fetch_Row($rs);
      $count = ODBC_Result($rs, 1);
      $max =  ODBC_Result($rs, 2);
      
      if($count == 0)
        return 1;
      else
        return ($max + 1);
    }
    
    function validate() {
      if(Empty($this->name)) {
        write_error("Name must be non-empty string!");
        return false;
      }
      return true;
    }
    
    function create() {
      $command = "INSERT INTO OBJECTS (OID, TYPE_ID, ONAME, ODESCR) VALUES (";
      $command .= $this->oid;
      $command .= ", ".$this->otid;
      $command .= ", '" . $this->name;
      $command .= "', '" . $this->descr;
      $command .= "')";
      
      //debug_trace($command);
      ODBC_Exec($this->conn, $command);
    }
    
    function modify() {
      $command = "UPDATE OBJECTS SET ONAME='";
      $command .= $this->name;
      $command .= "', ODESCR='".$this->descr;
      $command .= "' WHERE OID=" . $this->oid;

      //debug_trace($command);
      ODBC_Exec($this->conn, $command);
    }
    
    function load($oid) {
      $command = "SELECT OID, TYPE_ID, ONAME, ODESCR FROM OBJECTS WHERE OID=".$oid;

      //debug_trace($command);
      $rs = ODBC_Exec($this->conn, $command);
      if(!ODBC_Fetch_Row($rs))
        return false;
      $this->oid = ODBC_Result($rs, 1);
      $this->otid = ODBC_Result($rs, 2);
      $this->name = ODBC_Result($rs, 3);
      $this->descr = ODBC_Result($rs, 4);
      return true;
    }
    
    function canDelete() {
      return true;
    }
    
    function delete() {
      if($this->canDelete() == false) {return false;} //consistency check
      
      /* delete attributes */
      $this->delOAtrs();
      $this->delHAtrs();
      
      /* delete relationships (slave only)*/
      $command = "DELETE FROM RELATIONSHIPS WHERE OID_R=".$this->oid;
      ODBC_Exec($this->conn, $command);      
      
      /* delete object */
      $command = "DELETE FROM OBJECTS WHERE OID=".$this->oid;
      
      //debug_trace($command);
      ODBC_Exec($this->conn, $command);      
    }
    
    /* helper functions */
    function getTypeName() {
      $command = "SELECT TYPE_NAME FROM OBJ_TYPES WHERE TYPE_ID=".$this->otid;
    
      $rs = ODBC_Exec($this->conn, $command);
      ODBC_Fetch_Row($rs);
      return ODBC_Result($rs, 1);
    }
    
    function delOAtrs() {
      /* ordninal attributes */
      $command = "DELETE FROM O_OBJ_VALUES WHERE OID=".$this->oid;
      ODBC_Exec($this->conn, $command);
    }
      
    function delHAtrs() {
      /* hierarchical attributes */
      $command = "DELETE FROM H_OBJ_VALUES WHERE OID=".$this->oid;
      ODBC_Exec($this->conn, $command);
      
    }
    
    function getAtrCommand($atclass) {
      $command = "SELECT AT.ATRT_ID, AT.ATRT_NAME, OTA.OTA_MANDATORY";
      $command .= " FROM OBJ_TYPE_ATTRIBUTES OTA, ATTRIBUTE_TYPES AT";
      $command .= " WHERE OTA.TYPE_ID=".$this->otid;
      $command .= " AND AT.ATRT_CLASS='".$atclass;
      $command .= "' AND OTA.ATRT_ID = AT.ATRT_ID";
      $command .= " ORDER BY AT.ATRT_NAME";
      
      return $command;
    }
    
    function loadOAtrs() {
      /* generate associative array of existing elements */
      $command = "SELECT ATRT_ID, ATRT_VALUE FROM O_OBJ_VALUES WHERE OID=".$this->oid;
      $atrs = Array();
      $rs = ODBC_Exec($this->conn, $command);
      while(ODBC_Fetch_Row($rs)) {
        $atrs[ODBC_Result($rs, 1)] = ODBC_Result($rs, 2);
      }
      
      $allAtrs = Array();
      $rs = ODBC_Exec($this->conn, $this->getAtrCommand("O"));
      while(ODBC_Fetch_Row($rs)) {
        $atr = new Attribute;
        $atr->atid = ODBC_Result($rs, 1);
        $atr->atname = ODBC_Result($rs, 2);
        $atr->atflag = ODBC_Result($rs, 3) == "T" ? true : false;
        $atr->atvalue = $atrs[$atr->atid];  //retrieve existing value (if exists)
        $allAtrs[] = $atr;  //add to array
      }
      
      return $allAtrs;
    }
    
    function loadHAtrs() {
      /* generate associative array of existing elements */
      $command = "SELECT ATRT_ID, HATR_ID FROM H_OBJ_VALUES WHERE OID=".$this->oid;
      $atrs = Array();
      $rs = ODBC_Exec($this->conn, $command);
      while(ODBC_Fetch_Row($rs)) {
        $atrs[ODBC_Result($rs, 1)] = ODBC_Result($rs, 2);
      }
      
      $allAtrs = Array();
      $rs = ODBC_Exec($this->conn, $this->getAtrCommand("H"));
      while(ODBC_Fetch_Row($rs)) {
        $atr = new Attribute;
        $atr->atid = ODBC_Result($rs, 1);
        $atr->atname = ODBC_Result($rs, 2);
        $atr->atflag = ODBC_Result($rs, 3) == "T" ? true : false;
        $atr->atvalue = $atrs[$atr->atid];  //retrieve existing value (if exists)
        $allAtrs[] = $atr;  //add to array
      }
      
      return $allAtrs;
    }

    function writeOAtrs($oatrs) {
      $this->delOAtrs(); //delete first
      /* (re-)insert */
      
      if(!Is_Array($oatrs)) return;
      
      $command = "INSERT INTO O_OBJ_VALUES (OID, ATRT_ID, ATRT_VALUE)";
      $command .= " VALUES (?, ?, ?)";
      
      $pcmd = ODBC_Prepare($this->conn, $command);
      Reset($oatrs);
      $cnt = Count($oatrs);
      while($cnt--) {
//        debug_trace(Key($oatrs).": ".Current($oatrs));
        ODBC_Execute($pcmd, Array($this->oid, Key($oatrs), Current($oatrs)));        
        Next($oatrs);
      }
    }

    function writeHAtrs($hatrs) {
      $this->delHAtrs(); //delete first
      /* (re-)insert */

      if(!Is_Array($hatrs)) return;
      
      $command = "INSERT INTO H_OBJ_VALUES (OID, ATRT_ID, HATR_ID)";
      $command .= " VALUES (?, ?, ?)";
      
      $pcmd = ODBC_Prepare($this->conn, $command);
      Reset($hatrs);
      while(Current($hatrs)) {
        if(Current($hatrs) != -1) {
          ODBC_Execute($pcmd, Array($this->oid, Key($hatrs), Current($hatrs)));        
        }
        Next($hatrs);
      }
    }
  }
?>