<?

  function syn_err($err_msg) {
    echo "<p><b>SYNTAX ERROR:&nbsp;</b>$err_msg</p>\n";
  }

  function sem_err($err_msg) {
    echo "<p><b>SEMANTIC ERROR:&nbsp;</b>$err_msg</p>\n";
  }

  function print_array($arr) {
    for($i=0; $i<Count($arr); $i++)
      echo "$i = $arr[$i]<br>\n";
  }
  
  function getTypeId($conn, $type_name) {
    $command = "SELECT TYPE_ID FROM OBJ_TYPES WHERE TYPE_NAME='".$type_name."'";
      
    $rs = ODBC_Exec($conn, $command);
    if(!ODBC_Fetch_Row($rs)) {
      sem_err(sprintf("Type [%s] does not exist!", $type_name));
      return false;
    }
    else
      return ODBC_Result($rs, 1);
  }

  function getTypeName($conn, $type_id) {
    $command = "SELECT TYPE_NAME FROM OBJ_TYPES WHERE TYPE_ID=".$type_id;
      
    $rs = ODBC_Exec($conn, $command);
    if(!ODBC_Fetch_Row($rs)) {
      return false;
    }
    else
      return ODBC_Result($rs, 1);
  }

  function getAtrtId($conn, $atrt_name, &$hie) {
    $command = "SELECT ATRT_ID, ATRT_CLASS FROM ATTRIBUTE_TYPES WHERE ATRT_NAME='".$atrt_name."'";
      
    $rs = ODBC_Exec($conn, $command);
    if(!ODBC_Fetch_Row($rs)) {
      sem_err(sprintf("Attribute [%s] does not exist!", $atrt_name));
      return false;
    }
    else {
      $hie = (ODBC_Result($rs, 2) == "H") ? true : false;
      return ODBC_Result($rs, 1);
    }
  }
  
  function getRelationId($conn, $rln_name, $rev, $atrt_id, $atname) {
    $command = "SELECT RLN_ID FROM RELATION_TYPES WHERE";
    if($rev) { // Note: (OS base "xxx") means base("xxx", OS)
      $command .= " RLV_NAME='".$rln_name."'";
      $command .= " AND ATRT_ID_L=".$atrt_id;
    }
    else {
      $command .= " RLN_NAME='".$rln_name."'";
      $command .= " AND ATRT_ID_R=".$atrt_id;
    }
      
    $rs = ODBC_Exec($conn, $command);
    if(!ODBC_Fetch_Row($rs)) {
      sem_err(sprintf("%s relation [%s] for attribute type [%s] does not exist!", $rev ? "REV" : "" , $rln_name, $atname));
      return false;
    }
    else {
      return ODBC_Result($rs, 1);
    }
  }
  
  function objHasAttribute($conn, $otid, $atrt_id) {
    $command = "SELECT Count(*) FROM OBJ_TYPE_ATTRIBUTES WHERE TYPE_ID=".$otid;
    $command .= " AND ATRT_ID=".$atrt_id;
    $rs = ODBC_Exec($conn, $command);
    if(!ODBC_Fetch_Row($rs)) {
      return false;
    }
    else {
      return (ODBC_Result($rs, 1) > 0) ? true : false;
    }
  }

  function getHatrId($conn, $atrt_id, $atrt_name, $atrt_value) {
    $command = "SELECT HATR_ID  FROM H_ATRT_VALUES WHERE ATRT_ID=".$atrt_id;
    $command .= " AND ATRT_VALUE='".$atrt_value."'";

    $rs = ODBC_Exec($conn, $command);
    if(!ODBC_Fetch_Row($rs)) {
      sem_err(sprintf("Value [%s] does not exist in domain [%s]!", $atrt_value, $atrt_name));
      return false;
    }
    else
      return ODBC_Result($rs, 1);
  }
  
  function isOrdOp($an_op) {
    if($an_op == "=" || $an_op == "<>" 
    || $an_op == "<" || $an_op == ">"
    || $an_op == "<=" || $an_op == ">=")
      return true;
    else
      return false;
  }
  
  function getRspId($conn, $relname, $rev) {
    $command = "SELECT REL_ID FROM REL_TYPES WHERE";
    if($rev) { // Note: "a" JOIN "b" means rel("a", "b")
      $command .= " REV_NAME='".$relname."'";
    }
    else {
      $command .= " REL_NAME='".$relname."'";
    }
      
    $rs = ODBC_Exec($conn, $command);
    if(!ODBC_Fetch_Row($rs)) {
      sem_err(sprintf("%s relationship [%s] does not exist!", $rev ? "REV" : "" , $relname));
      return false;
    }
    else {
      return ODBC_Result($rs, 1);
    }
  }

  function getRspName($conn, $relid, $rev) {
    if($rev)
      $command = "SELECT REV_NAME FROM REL_TYPES WHERE REL_ID=".$relid;
    else
      $command = "SELECT REL_NAME FROM REL_TYPES WHERE REL_ID=".$relid;
    $rs = ODBC_Exec($conn, $command);

    if(!ODBC_Fetch_Row($rs)) {
      sem_err(sprintf("relationship with ID [%d] does not exist!", $relid));
      return "";
    }
    else {
      return ODBC_Result($rs, 1);
    }
  }  
 
  function isLegal($conn, $relid, $otid_l, $otid_r, $rev) {
    $command = "SELECT Count(*) FROM OBJ_TYPE_RELS WHERE REL_ID=".$relid;
    $command .= " AND TYPE_ID_L=".$otid_l;
    $command .= " AND TYPE_ID_R=".$otid_r;
    $rs = ODBC_Exec($conn, $command);
    if(!ODBC_Fetch_Row($rs)) {
      return false;
    }
    else {
      $res = (ODBC_Result($rs, 1) > 0) ? true : false;      
      if(!$res) {
        sem_err(sprintf("%s relationship [%s] is not defined between [%s] and [%s]",
          $rev ? "REV" : "",
          getRspName($conn, $relid, $rev),
          $rev ? getTypeName($conn, $otid_r) : getTypeName($conn, $otid_l),
          $rev ? getTypeName($conn, $otid_l) : getTypeName($conn, $otid_r)));
       }
      return $res;
    }
  }
  
?>