<?
  require "../rel_types/rsp_cache.php";

  class RelType {
    var $conn;  //connection handle
    
    var $oid;
    var $name;
    var $revName;
    var $cardinality;
    var $r;
    var $s;
    var $t;
    
    function RelType($conn) {
      $this->conn = $conn;
    }
    
    function newOid() {
      $rs = ODBC_Exec($this->conn, "SELECT Count(REL_ID) as _COUNT, Max(REL_ID) as _MAX FROM REL_TYPES");
      ODBC_Fetch_Row($rs);
      $count = ODBC_Result($rs, 1);
      $max =  ODBC_Result($rs, 2);
      
      if($count == 0)
        return 1;
      else
        return ($max + 1);
    }
    
    function validate() {
      if(Empty($this->name)) {
        write_error("Name must be non-empty string!");
        return false;
      }
      if(Empty($this->revName)) {
        write_error("RevName must be non-empty string!");
        return false;
      }
      return true;    }
    
    function create() {
      $command = "INSERT INTO REL_TYPES (REL_ID, REL_NAME, REV_NAME, REL_CARDINALITY, REL_R, REL_S, REL_T) VALUES (";
      $command .= $this->oid;
      $command .= ", '" . $this->name;
      $command .= "', '" . $this->revName;
      $command .= "', '" . $this->cardinality;
      $command .= "', '" . $this->r;
      $command .= "', '" . $this->s;
      $command .= "', '" . $this->t;
      $command .= "')";
      
      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)){
        write_error($php_errormsg);
        return false;
      }

      $rc = new RspCache($this->conn, $this->oid);
      return $rc->create();
    }
    
    function modify() {
      $command = "UPDATE REL_TYPES SET REL_NAME='";
      $command .= $this->name;
      $command .= "', REV_NAME='";
      $command .= $this->revName;
      $command .= "' WHERE REL_ID=" . $this->oid;

      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)){
        write_error($php_errormsg);
        return false;
      }
      return true;
    }
    
    function load($oid) {
      $command = "SELECT REL_ID, REL_NAME, REV_NAME, REL_CARDINALITY, REL_R, REL_S, REL_T FROM REL_TYPES WHERE REL_ID=".$oid;

      //debug_trace($command);
      $rs = ODBC_Exec($this->conn, $command);
      if(!ODBC_Fetch_Row($rs))
        return false;
      $this->oid = ODBC_Result($rs, 1);
      $this->name = ODBC_Result($rs, 2);
      $this->revName = ODBC_Result($rs, 3);
      $this->cardinality = ODBC_Result($rs, 4);
      $this->r = ODBC_Result($rs, 5);
      $this->s = ODBC_Result($rs, 6);
      $this->t = ODBC_Result($rs, 7);
      return true;
    }
    
    function delete() {
      /* delete cache */
      $rc = new RspCache($this->conn, $this->oid);
      if(!$rc->delete())
        return false;

      $command = "DELETE FROM REL_TYPES WHERE REL_ID=".$this->oid;
      
      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)){
        write_error($php_errormsg);
        return false;
      }
      return true;
    }
  }
?>