<?
  class RspCache {
    var $conn;  //connection handle
    
    var $rel_id; //relation identification
    
    function RspCache($conn, $rel_id) {
      $this->conn = $conn;
      $this->rel_id = $rel_id;
    }
    
    function create() {
      $command = "INSERT INTO RELATIONSHIPS_STAMPS (REL_ID, VALID) VALUES (";
      $command .= $this->rel_id;
      $command .= ", 0)";
      
      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      return true;
    }
    
    function delete() {
      /* cleat cache table content */
      $command = "sp_clr_rsp_cache(";
      $command .= $this->rel_id;
      $command .= ")";
      
      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      
      $command = "DELETE FROM RELATIONSHIPS_STAMPS WHERE REL_ID=".$this->rel_id;
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      return true;      
    }
    
    function isValid() {
      $command = "SELECT VALID FROM RELATIONSHIPS_STAMPS WHERE REL_ID=".$this->rel_id;
      $rs = @ODBC_Exec($this->conn, $command);
      if(!$rs) {
        write_error($php_errormsg);
        return false;
      }
      if(!@ODBC_Fetch_Row($rs)) {
        write_error(sprintf("Cache does not exist (REL_ID %d)", $this->rel_id));
        return false;
      }
      return ODBC_Result($rs, 1);
    }
    
    function invalidate() {
      $command = "UPDATE RELATIONSHIPS_STAMPS SET VALID=0 WHERE REL_ID=".$this->rel_id;
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      return true;
    }
    
    function validate($showProgress = false) {
      if($this->isValid()) {
        if($showProgress) {echo "OK<BR>\n"; }
        return true; //cache is valid, do nothing
      }
      if($showProgress) {echo "Rebuild<BR>\n"; }      
      
      /* re-initialize cache content */
      $command = "sp_init_rsp_cache(".$this->rel_id;
      $command .= ")";
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      
      $R;
      $S;
      $T;
      $this->getRelationInfo($R, $S, $T);
      if($S == "Y") {
        $command = "sp_rsp_symmetric(".$this->rel_id;
        $command .= ")";
        if(!@ODBC_Exec($this->conn, $command)) {
          write_error($php_errormsg);
          return false;
        }
      }
      if($T == "Y") {
        $newNumRows = $this->getCacheSize();
        do {
          $numRows = $newNumRows;
          
          $command = "sp_rsp_transitive(".$this->rel_id;
          $command .= ")";
          if(!@ODBC_Exec($this->conn, $command)) {
            write_error($php_errormsg);
            return false;
          }
          
          $newNumRows = $this->getCacheSize();
        } while($numRows < $newNumRows);
      }

      //set cache state to valid
      $command = "UPDATE RELATIONSHIPS_STAMPS SET VALID=1 WHERE REL_ID=".$this->rel_id;
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      return true;
    }

    /* internal helper functions */
    function getCacheSize() {
      $command = "SELECT COUNT(*) FROM RELATIONSHIPS_CACHE WHERE REL_ID=".$this->rel_id;
      
      /* if error -> whole script fails */
      $rs = ODBC_Exec($this->conn, $command);
      ODBC_Fetch_Row($rs);
      return ODBC_Result($rs, 1);
    }
    
    function getRelationInfo(&$R, &$S, &$T) {
      $command = "SELECT REL_R, REL_S, REL_T FROM REL_TYPES WHERE REL_ID=".$this->rel_id;

      /* if error -> whole script fails */
      $rs = ODBC_Exec($this->conn, $command);
      ODBC_Fetch_Row($rs);
      $R = ODBC_Result($rs, 1);
      $S = ODBC_Result($rs, 2);
      $T = ODBC_Result($rs, 3);
      
      return true;
    }
  }
?>