<?
  class RelationCache {
    var $conn;  //connection handle
    
    var $rln_id; //relation identification
    
    function RelationCache($conn, $rln_id) {
      $this->conn = $conn;
      $this->rln_id = $rln_id;
    }
    
    function create() {
      $command = "INSERT INTO RELATIONS_STAMPS (RLN_ID, VALID) VALUES (";
      $command .= $this->rln_id;
      $command .= ", 0)";
      
      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      return true;
    }
    
    function delete() {
      /* cleat cache table content */
      $command = "sp_clr_relations_cache(";
      $command .= $this->rln_id;
      $command .= ")";
      
      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      
      $command = "DELETE FROM RELATIONS_STAMPS WHERE RLN_ID=".$this->rln_id;
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      return true;      
    }
    
    function isValid() {
      $command = "SELECT VALID FROM RELATIONS_STAMPS WHERE RLN_ID=".$this->rln_id;
      $rs = @ODBC_Exec($this->conn, $command);
      if(!$rs) {
        write_error($php_errormsg);
        return false;
      }
      if(!@ODBC_Fetch_Row($rs)) {
        write_error(sprintf("Cache does not exist (RLN_ID %d)", $this->rln_id));
        return false;
      }
      return ODBC_Result($rs, 1);
    }
    
    function invalidate() {
      $command = "UPDATE RELATIONS_STAMPS SET VALID=0 WHERE RLN_ID=".$this->rln_id;
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      return true;
    }
    
    function validate($showProgress = false) {
      if($this->isValid()) {
        if($showProgress) {echo "OK<BR>\n"; }
        return true; //cache is valid, do nothing
      }
      if($showProgress) {echo "Rebuild<BR>\n"; }      
      
      /* re-initialize cache content */
      $command = "sp_init_relations_cache(".$this->rln_id;
      $command .= ")";
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      
      $R;
      $S;
      $T;
      $this->getRelationInfo($R, $S, $T);
      if($S == "Y") {
//        debug_trace("going sym");
        $command = "sp_relation_symmetric(".$this->rln_id;
        $command .= ")";
        if(!@ODBC_Exec($this->conn, $command)) {
          write_error($php_errormsg);
          return false;
        }
      }
//      debug_trace("T=".$T);
      if($T == "Y") {
//        debug_trace("going tran");
        $newNumRows = $this->getCacheSize();
        do {
          $numRows = $newNumRows;
//          debug_trace($numRows);
          
          $command = "sp_relation_transitive(".$this->rln_id;
          $command .= ")";
          if(!@ODBC_Exec($this->conn, $command)) {
            write_error($php_errormsg);
            return false;
          }
          
          $newNumRows = $this->getCacheSize();
        } while($numRows < $newNumRows);
      }
      if($R == "Y") {
//        debug_trace("going refl");
        $command = "sp_relation_reflexive(".$this->rln_id;
        $command .= ")";
        if(!@ODBC_Exec($this->conn, $command)) {
          write_error($php_errormsg);
          return false;
        }
      }

      //set cache state to valid
      $command = "UPDATE RELATIONS_STAMPS SET VALID=1 WHERE RLN_ID=".$this->rln_id;
      if(!@ODBC_Exec($this->conn, $command)) {
        write_error($php_errormsg);
        return false;
      }
      return true;
    }

    /* internal helper functions */
    function getCacheSize() {
      $command = "SELECT COUNT(*) FROM RELATIONS_CACHE WHERE RLN_ID=".$this->rln_id;
      
      /* if error -> whole script fails */
      $rs = ODBC_Exec($this->conn, $command);
      ODBC_Fetch_Row($rs);
      return ODBC_Result($rs, 1);
    }
    
    function getRelationInfo(&$R, &$S, &$T) {
      $command = "SELECT RLN_R, RLN_S, RLN_T FROM RELATION_TYPES WHERE RLN_ID=".$this->rln_id;

      /* if error -> whole script fails */
      $rs = ODBC_Exec($this->conn, $command);
      ODBC_Fetch_Row($rs);
      $R = ODBC_Result($rs, 1);
      $S = ODBC_Result($rs, 2);
      $T = ODBC_Result($rs, 3);
      
      return true;
    }
  }
?>