<?
  require "../relation_types/relation_cache.php";  
  
  class RelationType {
    var $conn;  //connection handle
    
    var $oid;
    var $name;
    var $revName;
    var $atrt_id_l;
    var $atrt_id_r;
    var $kind;
    var $r;
    var $s;
    var $t;
    
    function RelationType($conn) {
      $this->conn = $conn;
    }
    
    function newOid() {
      $rs = ODBC_Exec($this->conn, "SELECT Count(RLN_ID) as _COUNT, Max(RLN_ID) as _MAX FROM RELATION_TYPES");
      ODBC_Fetch_Row($rs);
      $count = ODBC_Result($rs, 1);
      $max =  ODBC_Result($rs, 2);
      
      if($count == 0)
        return 1;
      else
        return ($max + 1);
    }
    
    function validate() {
      $ret = true;
      if(Empty($this->name)) {
        write_error("Name must be non-empty string!");
        $ret = false;
      }
      if(Empty($this->revName)) {
        write_error("RevName must be non-empty string!");
        $ret = false;
      }
      if($this->atrt_id_l != $this->atrt_id_r) {
        if($this->r != "U") {
          write_error("Reflexive switch can be used for single dimension relations only!");
          $ret = false;
        }
        if($this->t != "U") {
          write_error("Transitive switch can be used for single dimension relations only!");
          $ret = false;
        }
        return $ret;
      }
      return true;    }
    
    function create() {
      $command = "INSERT INTO RELATION_TYPES (RLN_ID, RLN_NAME, RLV_NAME, ATRT_ID_L, ATRT_ID_R, RLN_KIND, RLN_R, RLN_S, RLN_T) VALUES (";
      $command .= $this->oid;
      $command .= ", '" . $this->name;
      $command .= "', '" . $this->revName;
      $command .= "', " . $this->atrt_id_l;
      $command .= ", " . $this->atrt_id_r;
      $command .= ", '" . $this->kind;
      $command .= "', '" . $this->r;
      $command .= "', '" . $this->s;
      $command .= "', '" . $this->t;
      $command .= "')";
      
      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)){
        write_error($php_errormsg);
        return false;
      }
      
      $rc = new RelationCache($this->conn, $this->oid);
      return $rc->create();
    }
    
    function modify() {
      $command = "UPDATE RELATION_TYPES SET RLN_NAME='";
      $command .= $this->name;
      $command .= "', RLV_NAME='";
      $command .= $this->revName;
      $command .= "' WHERE RLN_ID=" . $this->oid;

      //debug_trace($command);
      if(!@ODBC_Exec($this->conn, $command)){
        write_error($php_errormsg);
        return false;
      }
      return true;
    }
    
    function load($oid) {
      $command = "SELECT RLN_ID, RLN_NAME, RLV_NAME, ATRT_ID_L, ATRT_ID_R, RLN_KIND, RLN_R, RLN_S, RLN_T FROM RELATION_TYPES WHERE RLN_ID=".$oid;

      //debug_trace($command);
      $rs = ODBC_Exec($this->conn, $command);
      if(!ODBC_Fetch_Row($rs))
        return false;
      $this->oid = ODBC_Result($rs, 1);
      $this->name = ODBC_Result($rs, 2);
      $this->revName = ODBC_Result($rs, 3);
      $this->atrt_id_l = ODBC_Result($rs, 4);
      $this->atrt_id_r = ODBC_Result($rs, 5);
      $this->kind = ODBC_Result($rs, 6);
      $this->r = ODBC_Result($rs, 7);
      $this->s = ODBC_Result($rs, 8);
      $this->t = ODBC_Result($rs, 9);
      return true;
    }
    
    function delete() {
      /* delete cache */
      $rc = new RelationCache($this->conn, $this->oid);
      if(!$rc->delete())
        return false;
    
      /* delete ralation type data */
      $command = "DELETE FROM RELATIONS WHERE RLN_ID=".$this->oid;
       if(!@ODBC_Exec($this->conn, $command)){
        write_error($php_errormsg);
        return false;
      }
      
      /* delete relation type */
      $command = "DELETE FROM RELATION_TYPES WHERE RLN_ID=".$this->oid;
      
      //debug_trace($command);
       if(!@ODBC_Exec($this->conn, $command)){
        write_error($php_errormsg);
        return false;
      }
      return true;
    }
  }
  
  function LoadAttributeTypes($conn) {
    $command = "SELECT ATRT_ID, ATRT_NAME FROM ATTRIBUTE_TYPES WHERE ATRT_CLASS='H'";
    $ats;
    
    $rs = ODBC_Exec($conn, $command);
    while(ODBC_Fetch_Row($rs)) {
      $ats[ODBC_Result($rs, 1)] = ODBC_Result($rs, 2);
    }
    return $ats;
  }
?>