<HTML>
<HEAD>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Relations (browse)</TITLE>
</HEAD>
<BODY>
<TABLE cellspacing="2">
<TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository.php">Repository</a></TD>
</TR></TABLE>
<HR>
<H1>Relations (browse)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
?>
<?
  do {
    if(!$conn) {
      write_error(ERROR_CONNECT);
      break;
    }
    $command = "SELECT RLN_ID as ID, RLN_NAME as Name, RLV_NAME as RevName, AT_L.ATRT_NAME as AttributeTypeLeft, AT_R.ATRT_NAME as AttributeTypeRight, RLN_KIND as Kind, RLN_R as Reflexive, RLN_S as Symmetric, RLN_T as Transitive";
    $command .= " FROM RELATION_TYPES, ATTRIBUTE_TYPES AT_L, ATTRIBUTE_TYPES AT_R";
    $command .= " WHERE RELATION_TYPES.ATRT_ID_L = AT_L.ATRT_ID AND RELATION_TYPES.ATRT_ID_R = AT_R.ATRT_ID";
    if(IsSet($atrt_id_l) || IsSet($atrt_id_r)) {
      if(IsSet($atrt_id_l)) {
        $command .= " AND ATRT_ID_L=".$atrt_id_l;
      }
      if(IsSet($atrt_id_r)) {
        $command .= " AND ATRT_ID_R=".$atrt_id_r;
      }
    }
    //debug_trace($command);
    $rs = ODBC_Exec($conn, $command);
    if(!$rs) {
      write_error(ERROR_SELECT);
      break;
    }
    def_table_begin();
    echo "<tr>";
    $nCols = ODBC_Num_Fields($rs);
    for($col=1; $col<=$nCols; $col++) {
      echo "<th>".ODBC_Field_Name($rs, $col);
      echo "</th>";
    }
    echo "</tr>\n";
    while(ODBC_Fetch_Row($rs)){
      echo "<tr>";
      $oid = ODBC_Result($rs, 1);
      $name = ODBC_Result($rs, 2);
      if($name != "base")
        echo "<td><a href=\"detail.php?oid=$oid\">$oid</a></td>";
      else
        echo "<td>$oid</td>";
      echo "<td>$name</td>";
      for($col=3; $col<=$nCols-4; $col++) {
        echo "<td>".ODBC_Result($rs, $col);
        echo "</td>";
      }
      //kind column
      $val = ODBC_Result($rs, $nCols-3);
      if($val == 'L') {
        $val = "LATTICE";
      }
      else if($val == 'G') {
        $val = "GENERIC";
      }
      echo "<td>".$val."</td>";
      //last three columns (R, S, T)
      for($col=$nCols-2; $col<=$nCols; $col++) {
        $val = ODBC_Result($rs, $col);
        if($val == 'U') {
          $val = "NONE";
        }
        else if($val == 'Y') {
          $val = "YES";
        }
        else if($val == 'N') {
          $val = "ANTI";
        }
        echo "<td>".$val."</td>";
      }
       echo "</tr>\n";
    }    
    def_table_end();
    ODBC_Close($conn);
?>
<hr>
<p><em>INFO:</em> &quot;base&quot; relations are parts of the meta-repository.
They are managed using the <a href="../dimensions/browse.php">Dimensions</a> form.
<p><em>NOTE:</em> Relation kind &quot;LATTICE&quot; is reserved for dimensions only
in this release, however, you can create your custom relation types conforming to the <em>lattice</em>
structure manually.</p>
<?  
  } while(false); 
?>
</BODY>
</HTML>