<HTML>
<HEAD>
<LINK REL=StyleSheet HREF="../common.css" TYPE="text/css">
<TITLE>Relation types (detail)</TITLE>
</HEAD>
<BODY>
<TABLE cellspacing="2">
<TR>
<TD><A href="../index.html">Home</a></TD>
<TD>/</TD>
<TD><A href="../repository.php">Repository</a></TD>
</TR></TABLE>
<HR>
<H1>Relations (detail)</H1>
<? 
  require "../connect.php";
  require "../utils.php";
  require "../msgs.php";
  require "../shared.php";
  
  require "../relation_types/relation_type.php";    
?>
<?
  do {
    if(!$conn) {
      write_error(ERROR_CONNECT);
      break;
    }
    if($add) {
      $command = "INSERT INTO RELATIONS (RLN_ID, HATR_ID_L, HATR_ID_R)";
      $command .= " VALUES (".$oid;
      $command .= ", ".$left_val_id;
      $command .= ", ".$right_val_id;
      $command .= ")";
      
      @ODBC_Exec($conn, $command);
      
      $rc = new RelationCache($conn, $oid);
      $rc->invalidate();
    }
    if($delete) {
      List($oid, $l_id, $r_id) = Explode(",", $delete);
      /* delete record */
      
      $command = "DELETE FROM RELATIONS WHERE RLN_ID=".$oid;
      $command .= " AND HATR_ID_L=".$l_id;
      $command .= " AND HATR_ID_R=".$r_id;
      
      //debug_trace($command);
      ODBC_Exec($conn, $command);
      
      $rc = new RelationCache($conn, $oid);
      $rc->invalidate();
    }
    
    $command = "SELECT RLN_ID as ID, RLN_NAME as Name, RLV_NAME as RevName, AT_L.ATRT_NAME as AttributeTypeLeft, AT_R.ATRT_NAME as AttributeTypeRight, RLN_KIND as Kind, RLN_R as Reflexive, RLN_S as Symmetric, RLN_T as Transitive";
    $command .= " FROM RELATION_TYPES, ATTRIBUTE_TYPES AT_L, ATTRIBUTE_TYPES AT_R";
    $command .= " WHERE RELATION_TYPES.ATRT_ID_L = AT_L.ATRT_ID AND RELATION_TYPES.ATRT_ID_R = AT_R.ATRT_ID";
    $command .= " AND RLN_ID=".$oid;
    $rs = ODBC_Exec($conn, $command);
    if(!$rs) {
      write_error(ERROR_SELECT);
      break;
    }
    def_table_begin();
    echo "<tr>";
    $nCols = ODBC_Num_Fields($rs);
    for($col=1; $col<=$nCols; $col++) {
      echo "<th>".ODBC_Field_Name($rs, $col);
      echo "</th>";
    }
    echo "</tr>\n";
    while(ODBC_Fetch_Row($rs)){
      echo "<tr>";
      $oid = ODBC_Result($rs, 1);
      $name = ODBC_Result($rs, 2);
      if($name != "base")
        echo "<td><a href=\"detail.php?oid=$oid\">$oid</a></td>";
      else
        echo "<td>$oid</td>";
      echo "<td>$name</td>";
      for($col=3; $col<=$nCols-4; $col++) {
        echo "<td>".ODBC_Result($rs, $col);
        echo "</td>";
      }
      //kind column
      $val = ODBC_Result($rs, $nCols-3);
      if($val == 'L') {
        $val = "LATTICE";
      }
      else if($val == 'G') {
        $val = "GENERIC";
      }
      echo "<td>".$val."</td>";
      //last three columns (R, S, T)
      for($col=$nCols-2; $col<=$nCols; $col++) {
        $val = ODBC_Result($rs, $col);
        if($val == 'U') {
          $val = "NONE";
        }
        else if($val == 'Y') {
          $val = "YES";
        }
        else if($val == 'N') {
          $val = "ANTI";
        }
        echo "<td>".$val."</td>";
      }
       echo "</tr>\n";
    }    
    def_table_end();

    ?><p>Relation value pairs:</p><?
    
    $command = "SELECT REL.HATR_ID_L, HAV1.ATRT_VALUE, REL.HATR_ID_R, HAV2.ATRT_VALUE";
    $command .= " FROM RELATIONS REL, H_ATRT_VALUES HAV1, H_ATRT_VALUES HAV2";
    $command .= " WHERE REL.RLN_ID=".$oid;
    $command .= " AND REL.HATR_ID_L = HAV1.HATR_ID AND REL.HATR_ID_R = HAV2.HATR_ID";
    $command .= " ORDER BY HAV1.ATRT_VALUE, HAV2.ATRT_VALUE";
    
    //debug_trace($command);
    $rs = ODBC_Exec($conn, $command);
    if(!$rs) {
      write_error(ERROR_SELECT);
      break;
    }
    def_table_begin();
    while(ODBC_Fetch_Row($rs)):
      $lid = ODBC_Result($rs, 1);
      $lname = ODBC_Result($rs, 2);
      $rid = ODBC_Result($rs, 3);
      $rname = ODBC_Result($rs, 4);
      echo "<tr>";
        echo "<td>$lname</td><td>$rname</td>";
        echo "<td><a href=\"detail.php?delete=$oid,$lid,$rid\">delete</a></td>";
      echo "</tr>\n";
    endwhile;
    def_table_end();
    
    /* add pair section */
    $rt = new RelationType($conn);
    $rt->load($oid);
    $idsl = Array();$valsl = Array(); //left side
    $idsr = Array();$valsr = Array();  //right side
    
    loadAtrtVals($conn, $rt->atrt_id_l, $idsl, $valsl);
    if($rt->atrt_id_l == $rt->atrt_id_r) {  //same dimension
      $idsr = $idsl;
      $valsr = $valsl;
    }
    else {  //other dimension
      loadAtrtVals($conn, $rt->atrt_id_l, $idsr, $valsr);
    }
?>    
    <form action="detail.php" method="post">
      <input type="hidden" name="oid" value="<? echo $oid;?>">
      <table>
        <tr>
          <td>
            <SELECT  NAME="left_val_id" ALIGN="left" SIZE="1">
              <?for($i=0; $i<Count($idsl); $i++) {
                  echo "<OPTION  VALUE=\"".$idsl[$i]."\"";
                  echo ($left_val_id == $idsl[$i]) ? "SELECTED" : "";
                  echo ">".$valsl[$i];
                }?>  
            </SELECT>
          </td>
          <td>
            <SELECT  NAME="right_val_id" ALIGN="left" SIZE="1">
              <?for($i=0; $i<Count($idsr); $i++) {
                  echo "<OPTION  VALUE=\"".$idsr[$i]."\"";
                  echo ($right_val_id == $idsr[$i]) ? "SELECTED" : "";
                  echo ">".$valsr[$i];
                }?>  
            </SELECT>
          </td>
          <td>
            <input type="Submit" name="add" value="Add pair">
          </td>
         </tr>
      </table>
    </form>
<?    
    ODBC_Close($conn);
?>
<hr>
<form  action="browse.php" method="get">
<input  type="Submit" name="Browse" value="Browse">
</form>
<br>
<p><em>INFO:</em> &quot;base&quot; relations are parts of the meta-repository.
They are managed using the <a href="../dimensions/browse.php">Dimensions</a> form.
<?  
  } while(false); 
?>
</BODY>
</HTML>