-- OBSOLETE FILE!!! - only for historical reasons
-- superseded by RELOAD.SQL


--  ***************************************************************************
--  tables.sql : this script creates all the tables and integrity constraints
--  $Author: jg $
--  $Revision: 1.5 $
--  $Date: 1999/07/08 20:24:44 $
--  ***************************************************************************

--
-- DROP tables section (preserve order to respect defined constraints)
--
DROP TABLE TYPES;
DROP TABLE TYPE_CLASSES;
DROP TABLE PACKAGES;
DROP TABLE COMPONENT_TYPE_IO;

--
-- CREATE tables section (preserve order to respect defined constraints)
--

-- TYPE_CLASSES table
CREATE TABLE TYPE_CLASSES (
  TYPE_CLASS    INTEGER,
  CLASS_DESCR   VARCHAR(254) NOT NULL,
  -- constraints
  PRIMARY KEY (TYPE_CLASS)
);

-- TYPES table
CREATE TABLE TYPES (
  TYPE_ID         INTEGER,
  TYPE_DISPL_NAME VARCHAR(512) NOT NULL,
  TYPE_SIGNATURE  BINARY(128),
  TYPE_CLASS      INTEGER,
  -- constraints
  PRIMARY KEY (TYPE_ID),
  NOT NULL FOREIGN KEY (TYPE_CLASS) REFERENCES TYPE_CLASSES (TYPE_CLASS)
);


-- several views defined over table TYPES
DROP VIEW INTERFACES;
DROP VIEW COMPONENT_TYPES;
DROP VIEW CONNECTOR_TYPES;
DROP VIEW STRUCTURES;
DROP VIEW EXCEPTIONS;

CREATE VIEW INTERFACES AS SELECT TYPE_ID, TYPE_DISPL_NAME, TYPE_SIGNATURE FROM TYPES WHERE TYPE_CLASS = 1;
CREATE VIEW COMPONENT_TYPES AS SELECT TYPE_ID, TYPE_DISPL_NAME, TYPE_SIGNATURE FROM TYPES WHERE TYPE_CLASS = 2;
CREATE VIEW CONNECTOR_TYPES AS SELECT TYPE_ID, TYPE_DISPL_NAME, TYPE_SIGNATURE FROM TYPES WHERE TYPE_CLASS = 3;
CREATE VIEW STRUCTURES AS SELECT TYPE_ID, TYPE_DISPL_NAME, TYPE_SIGNATURE FROM TYPES WHERE TYPE_CLASS = 4;
CREATE VIEW EXCEPTIONS AS SELECT TYPE_ID, TYPE_DISPL_NAME, TYPE_SIGNATURE FROM TYPES WHERE TYPE_CLASS = 5;

-- PACKAGES table
CREATE TABLE PACKAGES (
  PACKAGE_ID      INTEGER,
  PACKAGE_NAME    VARCHAR(512) NOT NULL,
  PACKAGE_VERSION VARCHAR(10) NOT NULL,
  -- constraints
  PRIMARY KEY (PACKAGE_ID),
  UNIQUE (PACKAGE_NAME, PACKAGE_VERSION)
);

-- COMPONENT_TYPE_IO table
CREATE TABLE COMPONENT_TYPE_IO (
  COMPONENT_TYPE_ID  INTEGER NOT NULL,
  ROLE_NAME          VARCHAR(515) NOT NULL,
  ROLE_TYPE          CHAR(1) NOT NULL,	        -- 'P' (PROVIDES) OR 'R' (REQUIRES)
  ROLE_TYPE_ID       INTEGER NOT NULL,
  -- constraints
  PRIMARY KEY (COMPONENT_TYPE_ID, ROLE_NAME),
  NOT NULL FOREIGN KEY COMPONENT_TYPES_FK (COMPONENT_TYPE_ID) REFERENCES TYPES (TYPE_ID),  -- ensure it is type
  NOT NULL FOREIGN KEY INTERFACES_FK (ROLE_TYPE_ID) REFERENCES TYPES (TYPE_ID),            -- ensure it is type
  CHECK (ROLE_TYPE = 'P' OR ROLE_TYPE = 'R')
);

-- insert and update triggers to ensure:
-- 1) COMPONENT_TYPE_ID references TYPE_ID of TYPE_CLASS = 2  (Component type)
-- 2) ROLE_TYPE_ID references TYPE_ID of TYPE_CLASS = 1 (Interface type)
DROP TRIGGER BF_INST_OR_UPD;

CREATE TRIGGER BF_INST_OR_UPD BEFORE INSERT,UPDATE ORDER 1
ON COMPONENT_TYPE_IO
REFERENCING NEW AS newRow
FOR EACH ROW
BEGIN
  DECLARE err_invalid_ref_type EXCEPTION FOR SQLSTATE VALUE '99999';
  IF(SELECT COUNT(*) FROM COMPONENT_TYPES WHERE COMPONENT_TYPES.TYPE_ID=newRow.COMPONENT_TYPE_ID)=0 THEN
    signal err_invalid_ref_type;
  END IF;
  IF(SELECT COUNT(*) FROM INTERFACES WHERE INTERFACES.TYPE_ID=newRow.ROLE_TYPE_ID)=0 THEN
    signal err_invalid_ref_type;
  END IF
END